; 

.486                      ; create 32 bit code
.model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include \masm32\include\dialogs.inc
      include simple.inc

      dlgproc PROTO :DWORD,:DWORD,:DWORD,:DWORD
.data

.data?
    hButton dd ?
    hStatic dd ?
.code

; 

start:

      mov hInstance, FUNC(GetModuleHandle,NULL)
      Invoke InitCommonControls

      call main

      invoke ExitProcess,eax

; 

main proc

    ;Dialog "Simple Dialog","Ms Sans Serif",8, \            ; "Ms Sans Serif" Is NOT a TT font as "Microsoft Sans Serif" DOES
    Dialog "Simple Dialog","Microsoft Sans Serif",8, \            ; caption,font,pointsize
            WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \     ; style
            5, \                                            ; control count
            50,50,400,160, \                                 ; x y co-ordinates
            1024                                            ; memory buffer size
    ;
    ;SS_LEFT                              equ 0h
    ;SS_CENTER                            equ 1h
    ;SS_RIGHT                             equ 2h
    ;SS_CENTERIMAGE 			equ 200h
    ;SS_RIGHTJUST 			equ 400h
    ;SS_REALSIZEIMAGE 			equ 800h
    ;SS_SUNKEN 				equ 1000h
    ;SS_ENDELLIPSIS 			equ 4000h
    ;SS_REALSIZECONTROL               equ 00000040h
    ;SS_EDITCONTROL                   equ 00002000h    
    DlgStatic "Rotate Text.",SS_CENTER OR SS_SUNKEN OR SS_CENTERIMAGE,240,10,100,100,101
    DlgStatic "Angle:",SS_LEFT OR SS_CENTERIMAGE,240,120,20,12,102
    DlgEdit  WS_CHILD OR WS_BORDER OR WS_TABSTOP OR ES_AUTOHSCROLL OR ES_UPPERCASE OR 8000H,300,120,60,12,104
    ;UDS_WRAP        equ 0001h
    ;UDS_SETBUDDYINT equ 0002h
    ;UDS_ALIGNRIGHT  equ 0004h
    ;UDS_ALIGNLEFT   equ 0008h
    ;UDS_AUTOBUDDY   equ 0010h
    ;UDS_ARROWKEYS   equ 0020h
    ;UDS_HORZ        equ 0040h
    ;UDS_NOTHOUSANDS equ 0080h
    ;UDM_SETRANGE    equ WM_USER+101
    ;UDM_GETRANGE    equ WM_USER+102
    DlgComCtl "msctls_updown32",WS_CHILD OR WS_CLIPSIBLINGS OR WS_VISIBLE OR UDS_SETBUDDYINT OR UDS_AUTOBUDDY OR UDS_WRAP OR UDS_ALIGNRIGHT,160,120,12,12,105    
    ;
    ;BS_BOTTOM	
    ;BS_CENTER 
    ;BS_LEFT
    ;BS_RIGHT
    ;BS_TOP
    ;BS_VCENTER		           
    DlgButton "&OK",WS_TABSTOP OR BS_ICON OR BS_TEXT OR BS_TOP,8,8,20,120,IDCANCEL        
    CallModalDialog hInstance,0,dlgproc,NULL

    ret

main endp

; 

dlgproc                         proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
                                LOCAL cf:LOGFONT
                                LOCAL hFont:DWORD
                                LOCAL dAngle:DWORD

        
    .if uMsg == WM_INITDIALOG
        ;
        Invoke SendMessage,hWnd,WM_SETICON,1,FUNC(LoadIcon,NULL,IDI_ASTERISK)
        ;
        Invoke GetDlgItem,hWnd,IDCANCEL
        mov hButton,eax
        Invoke GetDlgItem,hWnd,101
        mov hStatic,eax
        ;
        invoke SendMessage,hButton,BM_SETIMAGE,1,FUNC(LoadIcon,NULL,IDI_ASTERISK)        
        ;        
        Invoke GetDlgItem,hWnd,105
        xor ecx,ecx
        mov cx,360
        Invoke SendMessage,eax,UDM_SETRANGE,0,ecx
        ; 
    .elseif uMsg == WM_VSCROLL
        Invoke GetDlgItemInt,hWnd,104,0,0
        xor edx,edx
        mov ecx,10
        mul ecx
        mov dAngle,eax
        Invoke SendMessage,hStatic,WM_GETFONT,0,0
        .if eax==NULL
            Invoke CreateFont, -12, 0,dAngle,dAngle, 0, 0, 0, 0, DEFAULT_CHARSET, 0, 0, 0, 0, 0
        .else                
            mov ecx,eax
            Invoke GetObject,ecx,sizeof LOGFONT, addr cf
            ;mov cf.lfHeight,-12
            ;mov cf.lfWidth,0
            mov eax,dAngle                                     
            mov cf.lfEscapement,eax
            mov cf.lfOrientation,eax
            ;mov cf.lfWeight,0 
            ;mov cf.lfItalic,TRUE
            ;mov cf.lfUnderline,TRUE
            ;mov cf.lfStrikeOut,TRUE
            ;mov cf.lfCharSet,DEFAULT_CHARSET
            ;mov cf.lfOutPrecision,OUT_TT_ONLY_PRECIS
            mov cf.lfClipPrecision,CLIP_DEFAULT_PRECIS ;, CLIP_LH_ANGLES	
            ;mov cf.lfQuality,ANTIALIASED_QUALITY
            ;mov cf.lfPitchAndFamily,0 
            ;mov cf.lfFaceName,0
            ;Invoke MessageBox,NULL,addr cf.lfFaceName,NULL,NULL 
            Invoke CreateFontIndirect,addr cf                
        .endif
        .if eax!=NULL
            mov hFont,eax
            Invoke SendMessage,hStatic,WM_SETFONT,hFont, 1
            Invoke SendMessage,hButton,WM_SETFONT,hFont, 1
        .endif
        ;Invoke DeleteObject,hFont       
        ;      
    .elseif uMsg == WM_COMMAND
      .if wParam == IDCANCEL
        jmp quit_dialog
      .endif

    .elseif uMsg == WM_CLOSE
      quit_dialog:
      invoke EndDialog,hWnd,0

    .endif

    xor eax, eax
    ret

dlgproc endp

; 

end start